
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Unity3d Android SDK接入解析（二）Unity3d Android SDK的设计与两种接入方式 / 憋错料</title>

    <meta name="description" content="Unity3d Android SDK接入解析（二）Unity3d Android SDK的设计与两种接入方式 一.前言 上篇说清楚了Unity和Android调用的方式,但很多实际接入的部分没有讲的很详细,因为重头在这篇,会详细讲述具体接入Android SDK的方式,和怎么去做一个方便Unity接入的SDK. 传送门: 前篇:Unity3d 与 Android之间的互相调用 http://blog.csdn.net/yang8456211/article/details/51331358 后篇:Unity3d Android SDK接入解析(三)接入Android Library的理解 http://">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Unity3d Android SDK接入解析（二）Unity3d Android SDK的设计与两种接入方式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>一、前言</h1>
<hr>
<br />上篇说清楚了Unity和Android调用的方式，但很多实际接入的部分没有讲的很详细，因为重头在这篇，会详细讲述具体接入Android SDK的方式，和怎么去做一个方便Unity接入的SDK。</p>
<p><strong>传送门：</strong></p>
<p>前篇：Unity3d 与 Android之间的互相调用</p>
<p><a href="http://blog.csdn.net/yang8456211/article/details/51331358" rel="external nofollow noreferrer">http://blog.csdn.net/yang8456211/article/details/51331358</a></p>
<p>后篇：Unity3d Android SDK接入解析（三）接入Android Library的理解</p>
<p><a href="http://blog.csdn.net/yang8456211/article/details/51435465" rel="external nofollow noreferrer">http://blog.csdn.net/yang8456211/article/details/51435465</a></p>
<h1>二、中篇：Unity3d Android SDK的设计与两种接入方式</h1>
<hr>
<h3>（Android SDK的接入一般分为两种）</h3>
<p>1）一种是把Unity的工程导出google project的形式进行接入</p>
<p>2）另一种是通过把Android的工程做成Plugins的形式进行接入</p>
<p><strong>对比：</strong></p>
<table>
<thead>
<tr>
<th>类别（形式）</th>
<th>google project</th>
<th>U3d Plugins</th>
</tr>
</thead>
<tbody>
<tr>
<td>优点</td>
<td>容易理解、方便接入原生SDK、几乎所有SDK都可以接入</td>
<td>接入方便、容易在Unity中进行扩展与管理</td>
</tr>
<tr>
<td>缺点</td>
<td>接入比较繁琐，对U3d项目不友好</td>
<td>不是所有SDK都提供U3d Plugins形式</td>
</tr>
<tr>
<td>apk导出</td>
<td>Android IDE导出</td>
<td>Unity 导出</td>
</tr>
</tbody>
</table>
<p><strong>建议：</strong></p>
<h5>如果做一个sdk，还是推荐分开Android形式的SDK（可以是Library），与Unity3d形式的SDK（Plugins），因为一般项目会有自己的SDK架构，而让他们打破这个架构，导出Google project的形式进行接入，这无疑是很难被接受的。</h5>
<h3>下面我们就来说一下具体的操作：</h3>
<pre><code>首先我们会自己写一个SDK,并说明白其中的注意点，然后会用两种方式接入这个SDK。
</code></pre>
<h2>2.1 一个简单Android SDK</h2>
<p>这个SDK实现几个小功能，实现四个方法：</p>
<ul>
<li>init方法，用来传入上下文</li>
<li>传入两个数返回他们的和</li>
<li>传入msg，弹出一个Toast提示</li>
<li>弹出一个提示窗口，窗口需要的文字信息从strings.xml里面获取，点击确认关闭</li>
</ul>
<p>先回答一个可能困惑大家问题：</p>
<h3>1）实现SDK时一定要存在一个中间件Activity继承UnityPlayerActivity吗？</h3>
<p>网上几乎所有教程都是这样教的，新建一个MyActivity，然后继承UnityPlayerActivity，在MyActivity里面写接口，然而根本没有讲清楚为什么要这样做。。</p>
<p>有关于这种方式的一些研究请看前篇：</p>
<p><a href="http://blog.csdn.net/yang8456211/article/details/51331358" rel="external nofollow noreferrer">http://blog.csdn.net/yang8456211/article/details/51331358</a>。</p>
<h3>2）让我们抛弃MyActivity吧</h3>
<p>对于1）的问题，答案是NO，简单说一下我的理解，只有当需要在Activity的生命周期中执行一些操作时，我们才需要一个中间Activity去完成这些与生命周期相关的操作，而其他情况下，一个Class足以。那就让我们开始吧：</p>
<ul>
<li>新建一个Android Project callAndroid</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNTM2MDgxNzQ=.jpg"></li>
<li>删除其中MainActivity和activity_main.xml
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNTM5NTcyNDA=.jpg"></li>
<li>新建一个Java class 取名CallMethod，写好上述四个方法。（可以自己先写写，然后看跟我写的有什么不一样）</li>
</ul>
<pre><code>public class CallMethod {
    private static Context unityContext;
    private static Activity unityActivity;
    private static AlertDialog.Builder alert;

    //init方法，用来传入上下文
    public static void init(Context paramContext){
        unityContext = paramContext.getApplicationContext();
        unityActivity = (Activity) paramContext;
    }

    //传入两个数返回他们的和
    public static int add(int arg0, int arg1){
        return arg0 + arg1;
    }

    //传入msg，弹出一个Toast提示
    public static void showMessage(final String msg){

        unityActivity.runOnUiThread(new Runnable()
        {
            public void run()
            {
                Toast.makeText(unityContext,msg, Toast.LENGTH_LONG).show();
            }
        });

    }

    //弹出一个提示窗口，窗口需要的文字信息从strings.xml里面获取，点击确认关闭
    public static void showAlertView(){

        alert = new AlertDialog.Builder(unityActivity).setTitle("弹出窗口").setMessage(unityContext.getResources().getIdentifier("msgAlert", "string", unityContext.getPackageName())).setPositiveButton("确认", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface arg0, int arg1) {
                // TODO Auto-generated method stub
                unityActivity.finish();
            }
        });

        unityActivity.runOnUiThread(new Runnable()
        {
            public void run()
            {
                alert.show();
            }
        });
    }
}</code></pre>
<p>这一小段代码，含金量可不小，能解决绝大部分你所遇到的问题~</p>
<p><strong>1. 不使用Activity，那Activity上下文怎么来?</strong></p>
<p>使用init的方法让Unity传当前上下文进来，我们就能拿到当前的Activity和应用上下文。（至于Unity怎么拿上下文，前篇我没有明确指出，但是我是有提的~请保持思考！）</p>
<p><strong>2. 怎么弹出窗口？怎么对界面进行操作?</strong></p>
<p>Unity调用Android方法默认不是在UI主线程上执行的，所以如果你想要对UI界面进行操作，那就要使用runOnUiThread才行。</p>
<p><strong>3. 使用Plugins接入的时候，怎么才能读到R的资源？</strong></p>
<p>这个问题困扰了我挺久的，因为直接把libs放入到Plugins中会导致读取不到资源，最后是通过反编译各种第三方SDK，才找到方法。此处是通过unityContext.getResources().getIdentifier(“msgAlert”, “string”, unityContext.getPackageName())这种java反射机制获取。（这里是获取了一个string,类比其他）</p>
<p><strong>4. 只能使用静态方法吗？</strong></p>
<p>当然不是，也可以使用实例方法，只是静态方法更容易调用，想要使用实例方法，我们可以创建一个单例，然后使用这个单例去调用实例方法。</p>
<pre><code>    private static CallMethod invokeSingleTon = null;

    public static CallMethod getInvokeClass(){
        if (invokeSingleTon == null){
            invokeSingleTon = new CallMethod();
        }
        return invokeSingleTon;
    }

    public void sayhello(){
        //方法内容
    }</code></pre>
<h3>3）怎么发布我们的SDK呢？</h3>
<p>此时我们就已经写好了我们的SDK，这个SDK比较健壮，怎么发布都行，可以勾上isLibrary以Android的库文件的形式进行发布；也可以分离出jar和res，以代码和资源的方式进行发布。</p>
<h2>2.2 一个简单Unity工程</h2>
<p>在写完AndroidSDK之后，我们简单的写一个Unity的工程，用来调用Android设置的接口。</p>
<ul>
<li>首先建立一个空的Unity工程，命名为UnityCall</li>
<li>选中摄像机MainCamera，新建一个CS脚本callAnd
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNTQ1MTE4MzY=.jpg"></li>
<li>绑定到Main Camera
<p>选中Main Camera，在add component的地方，选择刚才写的callAnd脚本</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNTU1MzMwODY=.jpg"></li>
</ul>
<p>cs脚本的代码：</p>
<pre><code>    AndroidJavaClass unityPlayer;
    AndroidJavaObject currentActivity;
    AndroidJavaClass androidCall;

    void Start () {
        //获取context
        unityPlayer = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
        currentActivity = unityPlayer.GetStatic&lt;AndroidJavaObject&gt;("currentActivity");
        androidCall = new AndroidJavaClass("com.atany.callandroid.CallMethod");
        androidCall.CallStatic("init",currentActivity);
    }

    void Update () {
    }

    void OnGUI()
    {
        GUI.skin.textArea.fontSize = 50;
        GUI.skin.button.fontSize = 50;

        // add
        if(GUI.Button(new Rect(100,300,450,300),"add"))
        {
            int sum = androidCall.CallStatic&lt;int&gt;("add",1,2);
            print ("sum is "+ sum);
        } 

        // showMessage
        if(GUI.Button(new Rect(600,300,450,300),"showMessage"))
        {
            androidCall.CallStatic("showMessage","显示这一段的文字");
        }

        // showAlertView
        if(GUI.Button(new Rect(100,700,450,300),"showAlertView"))
        {
            androidCall.CallStatic("showAlertView");
        }
    }</code></pre>
<p>画了三个button，用于调用我们设置好的Android三个不同的功能。</p>
<h2>2.3 导出Android工程进行接入</h2>
<p>首先呢，我们就先试一试导出Android工程的接入形式，把我们的Unity工程导出，然后接入我们的Android SDK。</p>
<ul>
<li>导出Android 工程（快捷键 Shift+Ctrl+b调出Build Settings）</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNjE1NTI0NzI=.jpg"></li>
<li>导入到IDE 这里使用eclipse，当然Idea也是一样的
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTExNjE4MTI2NDU=.jpg"></li>
</ul>
<p><em>注意：这里一定要选Existing Android Code Into Workspace，不要选Existing projects into Workspace</em></p>
<ul>
<li>我们把Android SDK打成jar+res（就一个stringnew.xml）的形式发布，加入到Unity导出的工程中。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDA2NDQwNzg=.jpg"></li>
</ul>
<p>-可以看到，我们就加入了两个东西，一个jar和一个xml，让我们跑起来看看效果</p>
<p><strong>add：</strong></p>
<p>点击add成功收到Unity3d打印的返回值。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDA4NTc5NDA=.jpg"></p>
<p><strong>showMessage：</strong></p>
<p>点击showMessage，成功在当前界面显示了toast。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDA3MzgxMjY=.jpg"></p>
<p><strong>showAlertView：</strong></p>
<p>点击showAlertView，成功在界面弹出了对话框</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDA3NDc1OTU=.jpg"></p>
<p>OK，到这里我使用导出google project的方法实现的android sdk的接入！也说明我们的资源读取的方式是正确的（取到stringnew里面的字符串资源），能够弹出对话框和Toast就意味着你能够实现各种可视化的界面操作。接着，我们看看怎么使用Unity插件的形式进行接入。</p>
<h2>2.4 使用Unity插件形式进行接入</h2>
<p>这种形式更加简单，简而言之就是以U3d要求的一种形式放好你的资源和jar包，然后就能够运行了~</p>
<ul>
<li>构建Plugins的形式</p>
<p>我们还是用之前新建的U3d的工程，记得开始的时候我们只添加了一个脚本，现在我们要在assets下面建立如下的结构：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDE3NDI5OTk=.jpg"></p>
<pre><code>Plugins：assets 下的根目录(下面可能有Android或者IOS)
Android：主目录
bin：放中间件的工程（我们没有建立MyActivity的中间件，如果有的话放在这里）
libs：放所有jar包
res：放所需要的资源
</code></pre>
</li>
<li>放入我们刚导出的Android SDK的libs和res
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MTIxMDI4MTEyMTU=.jpg"></li>
</ul>
<p><em>注意：</em></p>
<p>1.callAndroid的jar是放在libs里面的，stringnew这个xml是放在values里面的，我是通过多选让大家看看我添加的所有文件</p>
<p>2.如果bin里面有加入中间件MyActivity，或者有需要添加的权限以及Android的组件，需要放入AndroidManifest到Android目录下。</p>
<ul>
<li>运行效果和导出google project的效果是一样的，我就不重新贴图贴一次了。</li>
</ul>
<h3>总结：</h3>
<p>如果你跟着我做完了，你应该理解到的内容：</p>
<p>1. 正确的完成一个方便Unity接入的SDK</p>
<p>2. 使用导出工程的模式完成SDK的接入</p>
<p>3. 使用Unity插件的形式进行Android的接入</p>
<p>后篇我会讲讲具体的例子，怎么接入一个具体的Android的Library工程。</p>
<h1>三、demo地址</h1>
<h3>Android接入demo分为三个工程：</h3>
<ol>
<li>UnityCall：Plugins形式的Unity3d的工程</li>
<li>EclipseProj：Android的两个工程
<p>UnityPlayerNativeActivity：Unity3d导出式的工程</p>
<p>callAndroid：Android的sdk工程</li>
</ol>
<h3>下载地址：</h3>
<p><a href="http://download.csdn.net/detail/yang8456211/9517718" rel="external nofollow noreferrer">http://download.csdn.net/detail/yang8456211/9517718</a></p>
<p>杨光（atany）原创，转载请注明博主与博文链接，未经博主允许，禁止任何商业用途。</p>
<p>博文地址：<a href="http://download.csdn.net/detail/yang8456211/9517718" rel="external nofollow noreferrer">http://download.csdn.net/detail/yang8456211/9517718</a></p>
<p>博客地址：<a href="http://blog.csdn.net/yang8456211" rel="external nofollow noreferrer">http://blog.csdn.net/yang8456211</a></p>
<p>本文遵循“署名-非商业用途-保持一致”创作公用协议</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 02:49:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Unity3d Android SDK接入解析（二）Unity3d Android SDK的设计与两种接入方式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPBL6D3.html" rel="bookmark">Android -- service两种启动方式startService与bindService</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				继上一篇文章,Android – Service的使用,我们来继续看看Service的两种启动方式 第一种startService . 运行代码,得知以下几点结论: 我们了解它的启动周期为onCreate-&gt;onStartCommand,如图 当退出应用后,后台的Service进程仍然存在,未被销毁 当点击多次startService时,如图我点击了3次,你会发现onCreate方法只创建了一次. stopService,如图 第二种bindService 运行代码得知以下结论: 点击bindS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38ybG24.html" rel="bookmark">Android Bitmap 全面解析&lpar;二&rpar;加载多张图片的缓存处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般少量图片是很少出现OOM异常的,除非单张图片过~大~ 那么就可以用教程一里面的方法了通常应用场景是listview列表加载多张图片,为了提高效率一般要缓存一部分图片,这样方便再次查看时能快速显示~不用重新下载图片但是手机内存是很有限的~当缓存的图片越来越多,即使单张图片不是很大,不过数量太多时仍然会出现OOM的情况了~本篇则是讨论多张图片的处理问题-----------------------------------------------------------------------图片			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0agqrJ4.html" rel="bookmark">Android Service完全解析&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注册出处:http://blog.csdn.net/guolin_blog/article/details/9797169 在上一篇文章中,我们学习了Android Service相关的许多重要内容,包括Service的基本用法.Service和Activity进行通信.Service的销毁方式.Service与Thread的关系.以及如何创建前台Service.以上所提到的这些知识点,基本上涵盖了大部分日常开发工作当中可能使用到的Service技术.不过关于Service其实还有一个更加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoGdXBM.html" rel="bookmark">android快速上手（二）android开发环境搭建及hello world</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本了解了java语法,下一步,我们一起开启hello world的神秘之旅. (一)android开发环境搭建 之前搭建android开发环境是件非常费力的事情,下载Eclipse,安装ADT等,如今android官方给我们提供了全套配置. https://developer.android.com/sdk/index.html 搭建android开发环境之前记得先安装jdk (二)开启Hello World之旅 (1)创建Hello World项目 安装完带ADT的Eclipse,打开Ecl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MEjyK0.html" rel="bookmark">Android第五期 - 更新自己的apk本地与网络两种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先是本地: ParseXmlService部分: package com.szy.update; import java.io.InputStream; import java.util.HashMap; import javax.xml.parsers.DocumentBuilder; import javax.xml.parsers.DocumentBuilderFactory; import org.w3c.dom.Document; import org.w3c.dom.Element			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dxyEn0.html" rel="bookmark">Android中两种序列化方式的比较Serializable和Parcelable</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Serializable和Parcelable接口可以完成对象的序列化过程,当我们需要通过Intent和Binder传输数据时就需要使用者两种序列化方式.还有,我们需要对象持久化到存储设备或者通过网络传输给其他客户端,这个使用也需要使用Serializale来完成对象的序列化.在Android应用开发中,这两种方式都很常见,但两者方式并不相同. 1.Serializable接口 Serializable接口是Java提供的一个序列化接口,它是一个空接口,为对象提供标准的序列化和反序列化操作.使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MonWAD4.html" rel="bookmark">HyperLeger Fabric SDK开发（二）&mdash;&mdash;Fabric SDK配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HyperLeger Fabric SDK开发(二)--Fabric SDK配置 一.Fabric SDK配置 Fabric区块链网络应用程序需要大量的参数,用于连接Fabric区块链网络.通常将Fabric区块链网络应用程序所需的参数放到一个配置文件进行管理,配置文件定义Fabric SDK Go的配置和用户自定义参数,指定了连接Fabric区块链网络所需的全部信息,例如Fabric区块链网络组件的主机名和端口等.Fabric SDK GO为应用程序提供的配置文件通常使用yaml文件格式编写,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dljle0.html" rel="bookmark">Android Service的两种启动方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考链接 1. 概念 开始,先稍稍讲一点android中Service的概念和用途吧~ Service分为本地服务(LocalService)和远程服务(RemoteService): 1.本地服务依附在主进程上而不是独立的进程,这样在一定程度上节约了资源,另外Local服务因为是在同一进程因此不需要IPC, 也不需要AIDL.相应bindService会方便很多.主进程被Kill后,服务便会终止. 2.远程服务为独立的进程,对应进程名格式为所在包名加上你指定的android:process字符			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y8NrqM.html" rel="bookmark">Android四大组件之服务的两种启动方式详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Service简单概述 Service(服务):是一个没有用户界面.可以在后台长期运行且可以执行操作的应用组件.服务可由其他应用组件启动(如:Activity.另一个service).此外,组件可以绑定到服务,以与之进行交互,甚至是执行进程间通信 (IPC).例如:服务可以处理网络事务.播放音乐,执行文件 I/O 或与内容提供程序交互,而这一切均可在后台进行. 进程的优先级 了解进程的优先级可以帮助你理解服务~ 1. Foreground process(前台进程) 一句话总结:当前跟用户有交互			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kp573.html" rel="bookmark" class="title">Python迭代与递归方法实现斐波拉契数列</a>
					<div>
						首先是迭代的方法实现: def f(n): f1, f2, fn = 1, 1, 1 while n&gt;2: fn = f1 + f2 f1 = f2 f2 = fn n = n - 1 retu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyoRA3.html" rel="bookmark" class="title">寻找最大子串</a>
					<div>
						题目:从一个数组中寻找一个连续子数组,使其中元素之和最大,给出该和值. 例如:数组[-2, 1, -3, 4, -1, 2, 1, -5, 4]和最大的子串是[4, -1, 2, 1],其和为6. 分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDNoP3.html" rel="bookmark" class="title">Java魔法堂：JVM的运行模式</a>
					<div>
						一.前言 JVM有Client和Server两种运行模式.不同的模式对应不同的应用场景,而JVM也会有相应的优化.本文将记录JVM模式的信息,以便日后查阅. 二.介绍 在$JAVA_HOME/jre/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYeakM.html" rel="bookmark" class="title">linux&plus;php5&period;4&plus;nginx&plus;支持redis安装部署</a>
					<div>
						系统环境 [[email protected]~]# cat /etc/redhat-release CentOSrelease 6.5 (Final) [[email protected]~]# u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB1Zwj4.html" rel="bookmark" class="title">CODEVS5565 二叉苹果树</a>
					<div>
						n&lt;=100个点的根为1的二叉树,树边上有苹果,求保留Q&lt;=n条边的最多苹果数. 树形DP,f[i][j]--节点i为根的子树保留j条边最优方案,f[i][0]=0,f[i][j]=max ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYOqRM.html" rel="bookmark" class="title">java性能监控工具jstat</a>
					<div>
						jstat Monitors Java Virtual Machine (JVM) statistics. This command is experimental and unsupported.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOApX3.html" rel="bookmark" class="title">org&period;springframework&period;context&period;ApplicationContextAware使用理解</a>
					<div>
						一.这个接口有什么用? 当一个类实现了这个接口(ApplicationContextAware)之后,这个类就可以方便获得ApplicationContext中的所有bean.换句话说,就是这个类可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n5Wr7M.html" rel="bookmark" class="title">1051&colon; &lbrack;HAOI2006&rsqb;受欢迎的牛</a>
					<div>
						1051: [HAOI2006]受欢迎的牛 Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 2410  Solved: 1276[Submit][Sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGaa7a3.html" rel="bookmark" class="title">页面输入的数据格式转换类：BaseAction（常用于Struts框架中）</a>
					<div>
						在我们接收页面传来的数据时,这些数据都是以String类型接收的,所以要进行数据格式转换,这时候就可以统一为它们进行转换,而且在处理这些数据的类中可以继承ActionSupport类,然后让每一个接收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLZBXM.html" rel="bookmark" class="title">&lpar;Android review&rpar;ContentObserver</a>
					<div>
						1.一个应用通过ContentObserver来观察自己所监听的数据(某个特定的URI)是否发生了变化2.ContentObserver放在Activity中.CotentProvider专门写一个类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkKqP3.html" rel="bookmark" class="title">强大的vim编辑器</a>
					<div>
						哈哈,小编又来了,今天呢,小编将要给大家介绍Linux上强大的vim编辑器.首先呢,先给大家介绍一下什么是vim编辑器.Vim编辑器又叫文本编辑器,在vim工作下不需要图形界面,而是通过使用键盘命令进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNJgB4.html" rel="bookmark" class="title">C&num; DataTable分页处理</a>
					<div>
						public DataTable GetPagedTable(DataTable dt, int PageIndex, int PageSize)//PageIndex表示第几页,PageSize表示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOwvp3.html" rel="bookmark" class="title">Longest Substring Without Repeating Characters，求没有重复字符的最长字串</a>
					<div>
						问题描述: Given a string, find the length of the longest substring without repeating characters. Example ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpwap3.html" rel="bookmark" class="title">struts表单标签</a>
					<div>
						testfield标签: &lt;s:textfield size=&quot;尺寸&quot; maxlength=&quot;最大个数&quot; readonly=&quot;是否只读&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRxdJ3.html" rel="bookmark" class="title">SQL Server 服务器器信息备份（一）--login新建脚本备份</a>
					<div>
						前言 若你的企业使用SQL Server数据库镜像为容灾技术. 那你一定做过在镜像切换之前要新建Login,而且若Login密码不同,要修改链接数据库的字符串,在切换完之后则仍需要给数据库重新赋予权限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xaBrN3.html" rel="bookmark" class="title">关于内存映射文件记录</a>
					<div>
						预期目的: 进程A exe 当进程B打开某窗口挂载线程钩子DLL,监听鼠标消息.想在挂载钩子的时候申请内存 嵌套结构体如下: typedef struct strTmpGroup { strTmpGr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEara0.html" rel="bookmark" class="title">ubuntu14&period;04中利用samba访问linux&sol;windows共享目录的方法</a>
					<div>
						http://book.zhulang.com/312241/354052.html http://book.zhulang.com/312241/354053.html http://book.zh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2YkW0.html" rel="bookmark" class="title">CodeForces 449B - Jzzhu and Cities</a>
					<div>
						传送门:Jzzhu and Cities 题意: 题意一定要看仔细,这里说一个国家,有N个城市,城市与城市之间有M条路,距离为W,编号为1的城市是首都,1和K个城市有火车道,距离为X 现在国家要节省开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEweJ0.html" rel="bookmark" class="title">python的sorted函数</a>
					<div>
						sorted很简单,没太多好写的 ,只是给自己做个笔记. sorted接受三个参数,返回一个排序之后的list. 第一个接受一个可迭代的对象(根据duck typing,不一定需要list,可以迭代的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b5ZjpM.html" rel="bookmark" class="title">python 中的动态变量与静态变量</a>
					<div>
						变  量 变量的概念基本上和初中代数的方程变量是一致的,只是在计算机程序中,变量不仅可以是数字,还可以是任意数据类型. 变量在程序中就是用一个变量名表示了,变量名必须是大小写英文.数字和_的组合,且不 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
